<script setup lang="ts">
import { useEmpStore } from "../../stores/employee";
import { ref } from "vue";
import type { VForm } from "vuetify/components";
const form = ref<VForm | null>(null);
const employee = useEmpStore();
async function save() {
  const { valid } = await form.value!.validate();
  if (valid) {
    await employee.saveEmployee();
  }
}
</script>

<template>
  <v-dialog v-model="employee.dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">New Employee</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="form">
          <v-container>
            <v-row>
              <v-col cols="12" md="6">
                <v-text-field
                  label="Name*"
                  required
                  v-model="employee.editedEmployee.name"
                  :rules="[(v) => !!v || 'Name must not be null']"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6">
                <v-text-field
                  label="Surname*"
                  required
                  v-model="employee.editedEmployee.surname"
                  :rules="[(v) => !!v || 'Surname must not be null']"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Username*"
                  required
                  v-model="employee.editedEmployee.username"
                  :rules="[
                    (v) => !!v || 'Username must not be null',
                    (v) => v.length >= 4 || 'Length must more than 4',
                  ]"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Password*"
                  type="password"
                  required
                  v-model="employee.editedEmployee.password"
                  :rules="[
                    (v) => !!v || 'Password must not be null',
                    (v) => v.length >= 8 || 'Length must more than 8',
                  ]"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6">
                <v-text-field
                  label="Tel*"
                  required
                  v-model="employee.editedEmployee.tel"
                  :rules="[
                    (v) => !!v || 'Tel must not be null',
                    (v) => v.length >= 10 || 'Length must more than 10',
                  ]"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6">
                <v-select
                  :items="[
                    'Manager',
                    'Chef',
                    'waiter',
                    'Cashier',
                    'Assistant chef',
                  ]"
                  label="Role"
                  v-model="employee.editedEmployee.role"
                  :rules="[(v) => !!v || 'Role must not be null']"
                ></v-select>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="employee.dialog = false"
        >
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped></style>
